<template>
  <v-container v-if="articles.length > 0" class="transparent-background">
    <v-row>
      <v-col cols="12">
        <v-card id="welcome-card">
          <v-card-title class="text-break text-h3"
            >Bienvenue sur le site internet du RCS Escrime !
          </v-card-title>

          <v-card-text class="text--primary text-justify">
            Le Racing Club Sabre est un club d’escrime spécialisé dans le sabre,
            présent au cœur de la vallée de la Drôme dans les villes de Crest,
            Livron et Beaumont-lès-Valence.
            <br />
            Vous trouverez sur ce site tous les détails à connaître sur le club, 
            ainsi que toutes les informations pratiques.
            <br />
            Et pour découvrir les dernières actualités du club, c'est par ici ! ⬇️
          </v-card-text>
        </v-card>
      </v-col>

      <v-col
        v-for="(article, index) in articles"
        :key="article.slug"
        md="4"
        sm="6"
        cols="12"
      >
        <v-card height="100%" :color="cardColor" :to="article.path">
          <v-img
            class="align-end"
            :gradient="`to bottom, rgba(0, 0, 0, 0.25) 50%, ${cardColor}`"
            height="200px"
            :src="article.cover"
          >
            <v-card-title class="text-break">{{ article.title }}</v-card-title>
            <v-card-subtitle class="text-right text--primary">
              <template v-if="article.author">
                par {{ article.author }} le
              </template>
              {{ formatDate(article) }}
            </v-card-subtitle>
          </v-img>
          <v-divider />
          <v-card-text v-if="article.description" class="text--primary">{{
            article.description
          }}</v-card-text>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
  <v-container
    v-else
    fluid
    class="transparent-background text-center d-flex flex-column justify-center align-center"
  >
    <img src="img/logo.png" alt="RCS logo" height="200" />
    <h1>Racing Club Sabre</h1>
  </v-container>
</template>

<script>
export default {
  async asyncData({ $content, error }) {
    let articles
    try {
      articles = await $content('blog')
        .sortBy('date', 'desc')
        .only(['title', 'date', 'path', 'description', 'cover', 'author'])
        .fetch()
    } catch {
      error({
        statusCode: 500,
        message: 'Erreur en chargeant les articles de blog…',
      })
      return {}
    }

    return {
      articles,
    }
  },

  data() {
    return {
      cardColor: this.$vuetify.theme.currentTheme.info,
    }
  },

  methods: {
    formatDate(article) {
      const date = new Date(article.date)
      return date.toLocaleDateString('fr-FR', {
        year: 'numeric',
        month: 'long',
        day: 'numeric',
      })
    },
  },
}
</script>
